;:ts=8
; Copyright (C) 1986,1987 by Manx Software Systems, Inc.
;

;	Initial startup routine for Aztec C.

;	Adapted version for Link Handler

;	NOTE:	code down to "start" must be placed at beginning of
;		all programs linked with Aztec Linker using small
;		code or small data.

	include	"exec/types.i"
	include	"exec/alerts.i"
	include	"exec/execbase.i"

syscall	macro
	xref	_LVO\1
	jsr	_LVO\1(a6)
	endm

	section	text,code

	entry	.begin
	xdef	.begin

.begin
	bsr	_geta4			;get A4
	lea	__H1_end,a1
	lea	__H2_org,a2
	cmp.l	a1,a2			;check if BSS and DATA together
	bne	start			;no, don't have to clear
	move.w	#((__H2_end-__H2_org)/4)-1,d1
	bmi	start			;skip if no bss
	moveq	#0,d2

loop	move.l	d2,(a1)+		;clear out memory
	dbra	d1,loop

start	move.l	(4).w,a6		;get Exec's library base pointer
	move.l	a6,_SysBase		;put where we can get it

	lea	dos_name(pc),a1		;get name of dos library
	moveq	#0,d0			;any version
	syscall	OpenLibrary		;open the library
	move.l	d0,_DOSBase		;set it up
	bne	1$			;skip if okay

  	move.l  #AG_OpenLib!AO_DOSLib,d7
	syscall	Alert
	bra	2$

1$	jsr	_handler_process_startup

	move.l	d0,d2			;remember return code

	move.l	_DOSBase,d0		;lib still open?
	beq.s	2$			;nope

	move.l	d0,a1
	move.l	(4).w,a6
	syscall	CloseLibrary		;close it

	move.l	d2,d0

2$	rts				;and return

dos_name:
	dc.b	'dos.library',0

	xdef	_geta4
_geta4:
	far	data
	lea	__H1_org+32766,a4
	rts

	xref	_handler_process_startup

	section	data,data

	xref	_SysBase,_DOSBase
	xref	__H1_org,__H1_end,__H2_org,__H2_end
