		/**************************************
		 *                                    *
		 *   AmigaDOS Handler for XPK files   *
		 *                                    *
		 *        Prototypes and pragmas      *
		 *                                    *
		 **************************************/

	/* Prototypes - action.c */

LONG open_file(struct PacketData  *pd, struct DosPacket  *dp);
LONG close_file(struct PacketData  *pd, struct DosPacket  *dp);
LONG read_file(struct PacketData  *pd, struct DosPacket  *dp,
							  LONG *result_ptr);
LONG write_file(struct PacketData  *pd, struct DosPacket  *dp,
							  LONG *result_ptr);
LONG seek_file(struct PacketData  *pd, struct DosPacket  *dp,
							  LONG *result_ptr);
LONG get_current_volume(struct PacketData  *pd, struct DosPacket  *dp,
							  LONG *result_ptr);
LONG create_internal_lock(struct PacketData  *pd, struct DosPacket  *dp,
							    BPTR *lock_ptr);
LONG delete_internal_lock(struct PacketData  *pd, struct DosPacket  *dp);
LONG same_lock(struct PacketData  *pd, struct DosPacket  *dp,
							  LONG *result_ptr);
LONG duplicate_internal_lock(struct PacketData  *pd, struct DosPacket  *dp,
							    BPTR *lock_ptr);
LONG parent_internal_lock(struct PacketData  *pd, struct DosPacket  *dp,
							    BPTR *lock_ptr);
LONG get_file_info_block(struct PacketData  *pd, struct DosPacket  *dp);
LONG get_info_data(struct PacketData  *pd, struct DosPacket  *dp);
LONG create_dir(struct PacketData  *pd, struct DosPacket  *dp,
							    BPTR *lock_ptr);
LONG delete_object(struct PacketData  *pd, struct DosPacket  *dp);
LONG rename_object(struct PacketData  *pd, struct DosPacket  *dp);
LONG set_something(struct PacketData  *pd, struct DosPacket  *dp);

	/* Pragmas - action.c */

#pragma regcall(open_file(a0,a1))
#pragma regcall(close_file(a0,a1))
#pragma regcall(read_file(a0,a1,a2))
#pragma regcall(write_file(a0,a1,a2))
#pragma regcall(seek_file(a0,a1,a2))
#pragma regcall(get_current_volume(a0,a1,a2))
#pragma regcall(create_internal_lock(a0,a1,a2))
#pragma regcall(delete_internal_lock(a0,a1))
#pragma regcall(same_lock(a0,a1,a2))
#pragma regcall(duplicate_internal_lock(a0,a1,a2))
#pragma regcall(parent_internal_lock(a0,a1,a2))
#pragma regcall(get_file_info_block(a0,a1))
#pragma regcall(get_info_data(a0,a1))
#pragma regcall(create_dir(a0,a1,a2))
#pragma regcall(delete_object(a0,a1))
#pragma regcall(rename_object(a0,a1))
#pragma regcall(set_something(a0,a1))

	/* Prototypes - handler.c */

LONG handler_process_startup(VOID);
VOID handler_process_main(struct HandlerData  *hd);
struct HandlerData  *create_handler_data(struct Process  *pr,
						     struct DosPacket  *dp);
VOID delete_handler_data(struct HandlerData  *hd);
BOOL parse_argument_string(struct HandlerData  *hd, BPTR ss);
VOID link_volume_node(struct DeviceList  *vn);
VOID unlink_volume_node(struct DeviceList  *vn);

	/* Pragmas - handler.c */

#pragma regcall(handler_process_main(a0))
#pragma regcall(create_handler_data(a0,a1))
#pragma regcall(delete_handler_data(a0))
#pragma regcall(parse_argument_string(a0,a1))
#pragma regcall(link_volume_node(a0))
#pragma regcall(unlink_volume_node(a0))

	/* Prototypes - packet.c */

VOID packet_server_process_startup(VOID);
VOID packet_server_process_main(struct PacketData  *pd);

	/* Pragmas - packet.c */

#pragma regcall(packet_server_process_main(a0))

	/* Prototypes - subs.c */

BOOL   error_requester(BYTE *msg);
struct MsgPort  *create_process(struct MsgPort  *zombie_mp, VOID *code,
						     BYTE *name, LONG data);
LONG   send_packet(struct MsgPort  *mp, LONG type, ...);
VOID   put_packet(struct DosPacket  *dp, struct MsgPort  *mp,
						       struct MsgPort  *rp);
VOID   return_packet(struct DosPacket  *dp, LONG res1, LONG res2);
LONG   build_internal_lock(struct PacketData  *pd, BPTR real_lock,
						 LONG mode, BPTR *lock_ptr);
LONG   check_internal_lock(struct PacketData  *pd, BPTR lock);
SHORT  get_real_path(struct PacketData  *pd, struct DosPacket  *dp,
			BPTR lock, BSTR name, BYTE *buffer, USHORT max_len);
BPTR   get_real_lock(struct PacketData  *pd, BPTR lock);
struct MsgPort  *get_real_port(BPTR lock);
BYTE   *build_string(BYTE *text);
BSTR   build_bstring(BYTE *text);
VOID   create_temp_name(BYTE *buffer);
LONG   xpk_pack(ULONG, ...);
LONG   xpk_unpack(ULONG, ...);
LONG   xpk_examine(struct XpkFib  *xpk_fib, ULONG, ...);

	/* Pragmas - subs.c */

#pragma regcall(error_requester(a0))
#pragma regcall(create_process(a0,a1,a2,d0))
#pragma regcall(put_packet(a0,a1,a2))
#pragma regcall(return_packet(a0,d0,d1))
#pragma regcall(build_internal_lock(a0,a1,d0,a2))
#pragma regcall(check_internal_lock(a0,a1))
#pragma regcall(get_real_path(a0,a1,a2,a3,d0,d1))
#pragma regcall(get_real_lock(a0,a1))
#pragma regcall(get_real_port(a0))
#pragma regcall(build_string(a0))
#pragma regcall(build_bstring(a0))
#pragma regcall(create_temp_name(a0))
